<?php
/*

  The contents of this file are subject to the Mozilla Public License Version
  1.1 (the "License"); you may not use this file except in compliance with
  the License. You may obtain a copy of the License at

           http://www.mozilla.org/MPL/

  Software distributed under the License is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
  for the specific language governing rights and limitations under the License.

  The Original Code is ActionScriptFacile Framework.

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

*/


/**
 * @file Mysql.php
 *
 * @author Matthieu - www.actionscript-facile.com
 *
@usage

$oSqlConnection = new Mysql();
$s_sqlSelect = "SELECT visiteur, date FROM compteur_visite WHERE ip = '192.168.0.23'";
$o_sqlResult = $oSqlConnection->query($s_sqlSelect);
while ( $o_result = $oSqlConnection->getObject($o_sqlResult) )
{
	// caractristiques des messages
	$n_nbVisiteur = $o_result->nbvisiteur;
	$sDate =  $o_result->nbvisiteur;
}


$s_sqlSelect = "SELECT pseudo, date, website, message FROM guestbook WHERE enable = 1";
$s_sqlSelect .= " ORDER BY date DESC LIMIT 0, 50;
$o_sqlResult = $oSqlConnection->query($s_sqlSelect);

$a_Guestbook = array();
$i_cptMsg = 0;
while ( $o_result = $oSqlConnection->getObject($o_sqlResult) )
{
	$a_Guestbook[$i_cptMsg]["pseudo"] = $o_result->pseudo;
	$a_Guestbook[$i_cptMsg]["date"] = $s_date = $o_result->date;
	$a_Guestbook[$i_cptMsg]["website"] = $o_result->website;
	$a_Guestbook[$i_cptMsg]["message"] = $o_result->message;

	$i_cptMsg++;
}

*/


/**
 * @note : dans l'avenir cette classe tendra la classe PHP5 mysqli
 *
 */
class Mysql
{

	private $oLinkSql;
	private $oResult;

	private $aConnect;


	// ---------------------------------- __construct() ----------------------------------------------------------
	/**
	* @brief
	* @param -
	*/
	public function __construct()
	{
		$this->aConnect 	= array();
		$this->aConnect['ip']	= "serveur-mysql"; // le serveur
		$this->aConnect['login']= "login"; // le login
		$this->aConnect['password'] = "mot-de-passe"; // mot de passe
		$this->aConnect['database'] = "base-de-donnee"; // nom de la base de donnee
		$this->aConnect['port'] = "3306"; //


		if ( $this->oLinkSql = @mysqli_connect( $this->aConnect['ip'], $this->aConnect['login'], $this->aConnect['password'], $this->aConnect['database'], $this->aConnect['port'] ) )
		{
			$is_erreur = false ;
			$sql = 'SET CHARACTER SET \'utf8\'';
			$this->query($sql);
			$sql = 'SET collation_connection = \'utf8_general_ci\'';
			$this->query($sql);
		}
		else // erreur de connection - redirection vers une page web
		{
			echo "<meta http-equiv=\"refresh\" content=\"0; URL=erreurs/erreurBDD.htm\">";
			exit;
		}
	 }


	/**
	 * @brief Execute une requete
	 *
	 * @access public
	 * @param requete
	 * @return : FALSE in error else an objet who contain the result.
	 */
	public  function query($sSqlQuery)
	{
		if ( $this->oResult = @mysqli_query($this->oLinkSql,$sSqlQuery) ) return $this->oResult;
		else return 'Query : '.$sSqlQuery.' - error : '.@mysqli_error($this->oLinkSql);
	}


	/**
	 * @brief Liste les tables d'une base de donnees
	 *
	 * @return : object contenant la liste des tables.
	 */
	public function getTables()
	{
		return $this->query("SHOW TABLES FROM ".$this->aConnect['database']);
	}


	/**
	 * @brief Renvoie la configuration de la base de donnees (les acces)
	 *
	 * @return : un tableau qui contient tous les acces de la base
	 */
	public function getConfig()
	{
		return $this->aConnect;
	}



	/**
	 * @brief Renvoie le resultat d'une requete dans un objet
	 *
	 * @param (optionnel) pour recuperer le resultat d'une autre requete
	 */
	public function getObject($oResultQuery = NULL)
	{
		if($oResultQuery!=NULL)
		{
			return @mysqli_fetch_object($oResultQuery);
			if ( @mysqli_error($this->oLinkSql) ) return @mysqli_error($this->oLinkSql);
		}

		// donne le resultat de la requete courante
		if ($this->oResult != NULL)
		{
			return mysqli_fetch_object($this->oResult);
			if ( @mysqli_error($this->oLinkSql) ) return @mysqli_error($this->oLinkSql);
		}

	}



	/**
	 * @brief Donne le nombre d'enregitrement renvoye par la derniere requete
	 *
	 * @return (integer) le nombre d'enregitrement.
	 */
	public function getNumRows()
	{
		if( $this->oLinkSql != NULL && $this->oLinkSql != false)
		{
			return @mysqli_affected_rows($this->oLinkSql);
				if (@mysqli_error($this->oLinkSql)) return @mysqli_error($this->oLinkSql);
		}
	}


	/**
	 * @brief Renvoie l'identifiant du dernier enregitrement de la requete courante.
	 * @return (integer) the last insert id.
	 */
	public function lastInsertId()
	{
		return @mysqli_insert_id($this->oLinkSql);
	}


 	/**
	 * @brief Destructeur de la classe
	 *
	 * @return
	 */
	public function __destruct()
	{
		// Ferme la connection sql.
 		$this->oLinkSql = NULL ;
		$b_rep = @mysqli_close($this->oLinkSql);
		if( $b_rep != true )
			return 'Erreur closing sql connexion!';
 	}



	// ---------------------------------------- __toString() ----------------------------------------------------
	/**
	 * @brief Renvoie une representation sous forme de chaine de caractere de l'instance de cette classe.
	 * @usage   echo(myObject) ou print(myObject)
	 * @return  the string representation of this instance.
	 */
	public function __toString()
	{
		$s_classContent = "[Object ".__CLASS__."]<br />";

		foreach($this as $prop => $value)
		{
		 	$s_classContent .= "$prop => $value <br />";
		}

		return $s_classContent;
   	}

}
?>