package afterburner.model
{

	import flash.media.Sound;
	import flash.net.URLRequest;
	import flash.utils.Dictionary;
	import flash.events.Event;
	import flash.media.SoundChannel;
	
	
	import afterburner.view.util.Assets;
	
	
	import net.pixlib.quick.PXQuick;
	import net.pixlib.quick.model.PXQuickModel;
	import net.pixlib.commands.PXDelegate;
	

	public class SoundModel extends PXQuickModel
	{
		
		private var aSoundMP3 : Dictionary;// les sons chargés


		public function SoundModel()
		{
			super( ModelList.SOUND);
			this.init();
		}

		private function init() : void
		{
			aSoundMP3 = new Dictionary();

		}

		/**
		 * Lance le son de fond du jeu.
		 * 
		 * 
		 */
		public function playBackground() : void
		{
			PXQuick.play( Assets.getInstance().getSoundUrl("background") );
		}
		
	
		/**
		 * Joue un son suite à une action dans le jeu.
		 * 
		 */
		public function play(sURL : String) : void
		{
			//PXQuick.debug("SoundModel play :"+sURL);
			
			if(aSoundMP3[sURL+"_playing"] == true) return;// lecture un seul son à la fois
			
			// si l'objet son n'existe pas, on le charge
			if (aSoundMP3[sURL] == undefined)
				aSoundMP3[sURL] = new Sound(new URLRequest(sURL) );
			
			var oSound:Sound = aSoundMP3[sURL];
			aSoundMP3[sURL+"_playing"] = true;
			var oChannel:SoundChannel = oSound.play();
			oChannel.addEventListener(Event.SOUND_COMPLETE, PXDelegate.create(soundCompleteHandler, sURL+"_playing") );
		}


		/**
		 * La lecture du fichier son est terminée.
		 * 
		 */
		private function soundCompleteHandler(event : Event, sId:String) : void
		{
			//PXQuick.debug("soundCompleteHandler delegate play :"+sId, this);
			//PXQuick.debug(aSoundMP3, this);
			
			var oChannel:SoundChannel = SoundChannel(event.target);
			oChannel.removeEventListener(Event.SOUND_COMPLETE, soundCompleteHandler);
			aSoundMP3[sId] = false;
		}


	}
}