/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package afterburner.view.game.engine.elements
{
	
	import starling.core.Starling;
	import starling.display.MovieClip;
	import starling.textures.Texture;	
	

	/**
	 * Gestion des bédris d'un vaisseau après destruction par un missile.
	 * 
	 */
	public class DebrisVaisseau
	{
		private var oMovieVaisseau : MovieClip = null;
		
		private var rotationSpeedVaisseau : Number;
		private var nSpeedX : Number;
		private var nSpeedY : Number;
		private var nLifeVaisseau : int;
				
				
		/**
		 * Constructeur.
		 * Ajoute un ennemi positionné aléatoirement.
		 * 
		 */
		public function DebrisVaisseau(framesVaisseau:Vector.<Texture>)
		{
			this.init(framesVaisseau);
		}
		
		
		/**
		 * Init de la création de l'ennemi.
		 * 
		 */
		private function init(framesVaisseau:Vector.<Texture>) : void
		{
			/* init de l'affichage */
			oMovieVaisseau = new MovieClip(framesVaisseau, 60);
			
			/* init des caractéristiques vaiseau */
			rotationSpeedVaisseau = Math.random() * 0.4;
			nSpeedX = Math.random() * 30 - 15;
			nSpeedY = 5 + Math.random() * 5;
		
			Starling.juggler.add ( oMovieVaisseau );

			nLifeVaisseau = 100;
		}
		
		
		/**
		 * Renvoie le niveau de vie des débris.
		 * 
		 */
		public function get life() : int {return nLifeVaisseau;}


		/**
		 * Renvoie le clip pour ajout sur la scène
		 */
		public function get clip() : MovieClip {return oMovieVaisseau;}
		
		
		
		/**
		 * Mise à jour du mouvement de l'ennemis.
		 * 
		 */
		public function update() : void
		{
			if( oMovieVaisseau == null )	return;
			
			if( nLifeVaisseau > 0)
			{
				nLifeVaisseau --;
				
				nSpeedX *= 0.96; 
				oMovieVaisseau.x += nSpeedX;
				oMovieVaisseau.y += nSpeedY;
				oMovieVaisseau.rotation += rotationSpeedVaisseau;
				oMovieVaisseau.scaleX *= 0.96;
				oMovieVaisseau.scaleY *= 0.96;
			}
			
			if( nLifeVaisseau < 0)
				oMovieVaisseau.visible = false;
		}

		
		/**
		 * Supprime les ressources graphiques utilisées par l'ennemis.
		 * 
		 */
		private function remove() : void
		{
			if( oMovieVaisseau != null )
			{
				Starling.juggler.remove ( oMovieVaisseau );
				oMovieVaisseau.removeFromParent(true);
				oMovieVaisseau = null; 				
			}
			
		}


		/**
		 * Supprime les ressources utilisées par l'ennemis.
		 * 
		 */
		public function dispose() : void
		{
			this.remove();
		}
		
	}
}