/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package afterburner.view.game.stage3D
{
	
	import afterburner.view.ViewList;

	import flash.display.DisplayObject;
	import flash.geom.Point;

	import net.pixlib.plugin.PXPlugin;
	import net.pixlib.quick.PXQuick;
	import net.pixlib.view.PXContainerView;
	import starling.display.DisplayObjectContainer;
	
	import starling.display.MovieClip;
	import starling.events.Event;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;
	
	
	
	
	
	
	


	/**
	 * Utilisation du Framework 2D Starling.
	 * Couplé au système de gestion des vues Pixlib !
	 * 
	 */
	public class Avion extends PXContainerView
	{
		private var oMovie : MovieClip;
		
		
		private var mouseX : Number;// position de la souris
		private var mouseY : Number;
		private var offset : Number = 70;// correction pour position de l'avion
		
		private var oRocketManager : RocketManager;// gestion des balles tirées
		
		private var isFiring : Boolean;// le joueur tire
		
		
		private var oDisplay : DisplayObjectContainer;// le contenu Stage3D
		

		/**
		 * Constructeur vue Pixlib.
		 * 
		 */			
		public function Avion(owner : PXPlugin = null, mc : DisplayObject = null)
		{
			super(owner, ViewList.STAGE_3D_AVION, mc);
		}
		
		
		/**
		 * Methode appelez après l'instanciation d'une abstractUI
		 */
		override protected function onInitView() : void
		{
			hide();
		}
		
		
		public function setDisplay3D(display:DisplayObjectContainer, sTextureAtlas : TextureAtlas) : void
		{
			oDisplay = display;
			oRocketManager = RocketManager(PXQuick.getView(ViewList.STAGE_3D_ROCKETS) );	
			
			this.buildUI(sTextureAtlas);
		}

		/**
		 * Stage3D prêt.
		 * 
		 */
		private function buildUI(sTextureAtlas : TextureAtlas) : void
		{
			// ajout d'une texture
			var frames : Vector.<Texture> = sTextureAtlas.getTextures("fighter");

			// création de l'avion
			oMovie = new MovieClip(frames);
			oMovie.name = "fighter";
			oDisplay.addChild(oMovie);
						
			oDisplay.visible = false;
		}
		
		
		/**
		 * Renvoie le clip pour ajouté sur la scène
		 */
		public function getClip() : MovieClip {return oMovie;}
		
				
		
		/**
		 * Active les mise à jour toutes les frames.
		 * 
		 */
		public function onStartGame() : void
		{
			oDisplay.stage.addEventListener(Event.ENTER_FRAME, onFrame);// écouteur sur chaque image par seconde
			oDisplay.stage.addEventListener(TouchEvent.TOUCH, onTouch); // écouteur des mouvements de la souris sur la scène
			oDisplay.visible = true;
		}


		public function onStopGame() : void
		{
			oDisplay.stage.removeEventListener(Event.ENTER_FRAME, onFrame);// écouteur sur chaque image par seconde
			oDisplay.stage.removeEventListener(TouchEvent.TOUCH, onTouch); // écouteur des mouvements de la souris sur la scène
			oRocketManager.remove();
		}
		
		
		/**
		 * Permet de récupérer les coordonnées du pointeur - de la souris.
		 * 
		 */
		private function onTouch(e : TouchEvent) : void
		{
			// récupère la position de la souris par rapport à la scène
			var touch : Touch = e.getTouch(oDisplay.stage);
			
			if(touch)
			{
				if(touch.phase == TouchPhase.BEGAN)// le joueur touche l'écran
 					isFiring = true;
 
				else if(touch.phase == TouchPhase.ENDED)// le joueur ne touche plus l'écran
 					isFiring = false;
 
				else if(touch.phase == TouchPhase.MOVED)
				{}
				
				var pos : Point = touch.getLocation(oDisplay.stage);
				mouseX = pos.x;// sauvegarde des coordonnées de la sourie
				mouseY = pos.y;	
			}
		}
				
		
		/**
		 * Mise à jour de la position de l'avion.
		 * 
		 */
		private function onFrame(e : Event) : void
		{
			oMovie.x = this.mouseX - offset;
			oMovie.y = this.mouseY - offset - 20;
			
			if( isFiring ) oRocketManager.addRocket(oMovie.x+offset, oMovie.y+offset);
		} 
		
	}
}