/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package afterburner.view.game.stage3D
{

	import afterburner.event.EventList;
	import afterburner.view.ViewList;
	import afterburner.view.game.InterfaceView;
	import afterburner.view.util.Assets;
	
	
	import flash.display.DisplayObject;
	import flash.events.Event;
	
	
	import net.pixlib.events.PXNumberEvent;
	import net.pixlib.events.PXObjectEvent;
	import net.pixlib.plugin.PXPlugin;
	import net.pixlib.quick.PXQuick;
	import net.pixlib.view.PXContainerView;
	
	
	import starling.display.Button;
	import starling.display.DisplayObjectContainer;
	import starling.events.Event;
	import starling.text.BitmapFont;
	import starling.text.TextField;
	import starling.textures.Texture;
	import starling.utils.HAlign;
	import starling.utils.VAlign;
	

	/**
	 * Utilisation du Framework 2D Starling.
	 * 
	 */
	public class Interface3D extends PXContainerView
	{
		private var oTextScore : TextField;
		private var sPrefix:String;
		private var nScore:int;
		
		/* for FPS display */
		//private var nLastTime : uint = getTimer();
		//private var ticks : uint = 0;
		//private var oTextFPS : TextField;
		//private var text : String = "--.- FPS";
		
		
		private var oDisplay : DisplayObjectContainer;
		private var oTextHighScore : TextField;
		
		
		private var oBtnMenu : Button;
		private var oBtnNamePlayer : Button;


		
		public function Interface3D(owner : PXPlugin = null, mc : DisplayObject = null)
		{
			super(owner, ViewList.STAGE_3D_INTERFACE, mc);
		}

		
		/**
		 * Methode appelez après l'instanciation d'une abstractUI
		 */
		override protected function onInitView() : void
		{
			hide();
		}
		
		
		public function setDisplay3D(display:DisplayObjectContainer) : void
		{
			oDisplay = display;

			this.buildUI();
		}
		
		
		/**
		 * Stage3D prêt.
		 * 
		 */
		private function buildUI() : void
		{
			sPrefix = "Score : ";
			nScore = 0;
			
			this.addTexts();
			this.addMenu();
		}

		
		/**
		 * Appel par une commande.
		 * 
		 */
		public function onStopGame() : void
		{
			//logger.debug("Interface3D onStopGame", this);
			oBtnNamePlayer.visible = true;
			oBtnMenu.visible = true;
		}
		
		
		/**
		 * Prépare le lancement d'une nouvelle partie.
		 * 
		 */
		public function onStartGame() : void
		{
			nScore = 0;
			oBtnNamePlayer.visible = false;
			oTextHighScore.text = "";
		}

		
		/**
		 * Mets à jour le nombre de FPS du jeu.
		 * 
		 */
		public function update() : void
		{
			return;/*
			ticks++;
			var nNowTimer : uint = getTimer();
			var delta : uint = nNowTimer - nLastTime;
			if (delta >= 1000)
			{
				var fps : Number = ticks / delta * 1000;
				text = fps.toFixed(1) + " FPS";
				ticks = 0;
				nLastTime = nNowTimer;
			}
			oTextFPS.text = text;*/
		}
		
		
		/**
		 * Mets à jour la liste des High Score
		 */
		public function updateHighScore(oData:Object) : void
		{
			/*logger.debug(" updateHighScore: ", this);
			logger.debug(oData, this);*/

			var aListePlayers:Array = oData.players as Array;
						
			var oInfos:Object;
			var sTemp:String = "Les Meilleurs Score :\n\n";
			for (var i : int = 0; i < aListePlayers.length; i++)
			{
				oInfos = aListePlayers[i];
				sTemp += String(oInfos.number)+". "+String(oInfos.name)
				+" : "+String(oInfos.score)+" points - "+String(oInfos.date)+"\n\n";
			}
			oTextHighScore.text = sTemp;
		}

			
		/**
		 * Appel par un évènement CollisionModel après le chargement des éléments graphiques.
		 * 
		 * content pour récupérer le DisplayObject en cours.
		 * 
		 */
		public function onUpdateScore(event : PXNumberEvent) : void
		{
			//logger.debug(" txt onUpdateScore : "+event.value, this);
			
			nScore += event.value;
			if(nScore<0)	nScore = 0;
			
			// ajoute des zeros avant le score
			var sTemp:String = nScore.toString();

			while (sTemp.length < 5)	sTemp = "0" + sTemp;
			
			oTextScore.text = sPrefix+sTemp;
		}
		
		
		
		/**
		 * Ajoute les textes FPS et score.
		 * 
		 */
		private function addTexts() : void
		{
			// ajout d'une texture
			var texture:Texture = Assets.getInstance().getTexture("OnkyFontChars");
			var xml : XML = Assets.getInstance().getDataXml("OnkyFontXML");
			
			// enregistre la police pour la rendre accessible à l'objet TextField
			TextField.registerBitmapFont(new BitmapFont(texture, xml));
			
			//PXQuick.debug("Interface ", this);
			
			var sFontName:String = "Onky";
			
			// création de l'objet TextField
			oTextScore = new TextField(480, 40, "Score : 00000", sFontName, BitmapFont.NATIVE_SIZE, 0x006f77);
			// définit la taille native du fichier png à la police, pas de scaling (déformation des images)

			// positionne le texte sur la scène
			oTextScore.x = 180;
			oDisplay.addChild(oTextScore);
			
			
			// création de l'objet TextField FPS
			/*oTextFPS = new TextField(180, 40, text, sFontName, BitmapFont.NATIVE_SIZE, 0x006f77);
			oTextFPS.x = 10;
			oDisplay.addChild(oTextFPS);*/
			
			texture = Assets.getInstance().getTexture("RacerFontChars");
			xml = Assets.getInstance().getDataXml("RacerFontXML");
			// enregistre la police pour la rendre accessible à l'objet TextField
			TextField.registerBitmapFont(new BitmapFont(texture, xml));
			
			// Ajoute le texte de gestion de la liste des High Score.
			oTextHighScore = new TextField(580, 700, "Les Meilleurs Scores :", "Racer", BitmapFont.NATIVE_SIZE, 0x006f77);
			oTextHighScore.x = 20;
			oTextHighScore.y = 50;
			oTextHighScore.hAlign = HAlign.LEFT;
			oTextHighScore.vAlign = VAlign.TOP;
			oDisplay.addChild(oTextHighScore);
		}
			
				
		/**
		 * Ajoute le menu du jeu.
		 * 
		 */
		private function addMenu() : void
		{
			// création de nos textures pour notre bouton
			var oTextureBtnUp : Texture = Assets.getInstance().getTexture("ButttonNormal");
			var oTextureBtnDown : Texture = Assets.getInstance().getTexture("ButtonDown");
			
			// création d'un bouton du menu en utilisant les textures et le texte
			oBtnMenu = new Button(oTextureBtnUp, "Jouer", oTextureBtnDown);
			
			oBtnMenu.fontBold = false;// texte en gras
			oBtnMenu.scaleWhenDown = 0.9;// effect lorsque le bouton est cliqué
			oBtnMenu.fontName = "Onky";// attribution de la police embarquées
			oBtnMenu.fontColor = 0x006f77;// couleur du texte
			oBtnMenu.fontSize = 31;// taille de la police
			
			oBtnMenu.x = 250;
			oBtnMenu.y = 700;
			oDisplay.addChild(oBtnMenu);
			
			// écoute l'évènement Event.TRIGGERED, lorsqu'un bouton est cliqué 
			oBtnMenu.addEventListener(starling.events.Event.TRIGGERED, onButtonTriggered); 
			
			
			// à la fin de la partie pour la saisie du nom du joueur.
			oBtnNamePlayer = new Button(oTextureBtnUp, "Ok", oTextureBtnDown);
			oBtnNamePlayer.fontBold = false;// texte en gras
			oBtnNamePlayer.scaleWhenDown = 0.9;// effect lorsque le bouton est cliqué
			oBtnNamePlayer.fontName = "Onky";// attribution de la police embarquées
			oBtnNamePlayer.fontColor = 0x006f77;// couleur du texte
			oBtnNamePlayer.fontSize = 34;// taille de la police
			
			oBtnNamePlayer.x = 250;
			oBtnNamePlayer.y = 150;
			oDisplay.addChild(oBtnNamePlayer);
			oBtnNamePlayer.visible = false;
			
			// écoute l'évènement Event.TRIGGERED, lorsqu'un bouton est cliqué 
			oBtnNamePlayer.addEventListener(starling.events.Event.TRIGGERED, onSaveScore);	
		}
		
		
		/**
		 * Click de l'utilisateur sur le menu.
		 * Sauvegarde le score dans la base de données.
		 * 
		 */
		private function onSaveScore(e:starling.events.Event) : void
		{
			//logger.debug("Interface3D onButtonTriggered ", this);
			Button(e.target).visible = false;
			
			var oData:Object = new Object();
			oData.name = InterfaceView(PXQuick.getView(ViewList.INTERFACE) ).getPlayerName();
			oData.score = nScore;
			firePrivateEvent(new PXObjectEvent(EventList.addNewScoreEvent, null, oData));// lance une commande
		}
		
		
		/**
		 * Click de l'utilisateur sur le menu.
		 * 
		 */
		private function onButtonTriggered(e:starling.events.Event) : void
		{
			//logger.debug("Interface3D onButtonTriggered ", this);
			
			Button(e.target).visible = false;
			firePrivateEvent(new flash.events.Event(EventList.onStartGame));// lance une commande
		}
		
	}
}